<?php if (!defined('PmWiki')) exit();

/***********************************************************************
* Adds a trail of recent links visited to PmWiki, just add the variable 
* $Path_History in the appropriate place to your {Skin}.tmpl. The number 
* of links added is controlled by setting the $num_links value in this 
* recipe. The separator is controlled by changing the $separator 
* variable.
* Note that it ignores (i.e.; doesn't add) 'Home Page' links. This works 
* very well for me as I tend to have a subjects .HomePage link in 
* Site.SideBar and typically have pages under that subject four or five 
* levels deep, so with this I can bounce around within a subjects 
* sub-pages pretty easily.
* Don't forget to add:
* "@include_once("cookbook/path_history.php");" to config.php.
* I did this pretty quickly so please feel free to fix/clean/enhance and 
* repost it back up. (ksc, 20061116)
***********************************************************************/

global $Path_History;
$RecipeInfo['Path_History']['Version'] = '20061116-1';

$num_links = 4;
$separator = "&nbsp;|&nbsp;";

$Path_History = "";
$t = "";
$name =  FmtPageName('$Titlespaced', $pagename);
$url =  FmtPageName('$PageUrl', $pagename);

# shouldn't need this since the session is started elsewhere, but my 
# session kept evaporating.
if (!isset($_SESSION)) { session_start(); }

# make sure the Session var's are there
if (!isset($_SESSION['history'])) { $_SESSION['history'] = array(); }
if (!isset($_SESSION['hist_name'])) { $_SESSION['hist_name'] = array(); }

# ignore .HomePage, not sure where the weirdness with $Name is coming from
if ($name != "Home Page" && $name != "\$Name") {
	list($n, $u) = end($_SESSION['history']);
	# don't add duplicates. no way to easily search a multi-dim array so.....
	$t = array_search($name, $_SESSION['hist_name']);
	if ( $n != $name && $u != $url && $t === false) {
		$_SESSION['history'][] = array($name,$url);
		$_SESSION['hist_name'][] = $name;
		# drop off old entries
		while (count($_SESSION['history']) > $num_links) {
			array_shift($_SESSION['history']);
		}
		while (count($_SESSION['hist_name']) > $num_links) {
			array_shift($_SESSION['hist_name']);
		}
	}
}

# load the new history
for ($i = 0; $i < sizeof($_SESSION['history']); $i++) {
	list($n, $u) = $_SESSION['history'][$i];
	$Path_History .= $separator."<a href=\"".$u."\">".$n."</a>";
}

?>
